#!/usr/bin/perl

########################################################################
#                                                                      #
# SurrealServices Database Dumper 0.1.2                                #
#                                                                      #
# This was written b/c the mysqldump program we had was broken.        #
# It will be made both stupid enough and generic enough that it may    #
# be used for other databases as well.                                 #
#                                                                      #
#  (C) Copyleft tabris@surrealchat.net 2005, 2006                      #
#   All rights reversed, All wrongs avenged.                           #
#                                                                      #
#                                                                      #
#                                                                      #
#                                                                      #
#                                                                      #
########################################################################

use strict;
use DBI;
use libs::config;
use Cwd 'abs_path';
use File::Basename;
my $drop_table = 1;

my $prefix = dirname(abs_path($0));
my %config = config::readHash("$prefix/config/services.conf");

my $dbh = DBI->connect(
	"DBI:mysql:".$config{'mysql-db'}.":mysql_server_prepare=1",
	$config{'mysql-user'},
	$config{'mysql-pass'},
	{
		AutoCommit => 1,
		RaiseError => 1
	}
);

my @tables = ( 'akick', 'bot', 'chan', 'chanacc', 'chanclose',
	'chanlvl', 'chanperm', 'chanreg', 'ircop', 'logonnews', 'memo',
	'ms_ignore', 'nickalias', 'nickid', 'nickreg', 'sesexname',
	'sesexip', 'qline', 'silence', 'svsop', 'user', 'vhost',  
	'watch', 'welcome'
);

foreach my $table (@tables) {
	{
		my $get_table = $dbh->prepare("SHOW CREATE TABLE `$table`");
		$get_table->execute();
		my $result = $get_table->fetchrow_array;

		print "DROP TABLE IF EXISTS `$table`;" if $drop_table;
		print "\n--\n-- Table structure for table `$table`\n--\n".
			"$result;\n".
			"\n--\n-- Dumping data for table '$table'\n--\n";

		$get_table->finish();
	}

	my $results = $dbh->selectall_arrayref('SELECT * FROM '."`$table`");
	foreach my $row (@$results) {
		foreach my $element (@$row) {
			$element = $dbh->quote($element);
		}
		print "INSERT INTO `$table` VALUES (".join(',', @$row).");\n";
	}
}
