#!/usr/local/bin/perl

use strict;

my %tok_hash;
my $debug = 0;

open MSGH, "include/msg.h";
while (my $l = <MSGH>) {
	chomp $l;
	if ($l =~ /^#define(\s|\t)MSG_(\w+)(\s|\t)+\"(\S+)\".*/) {
		$tok_hash{$2}->{MSG} = $4;
		print $l."\n" if $debug;
		print "$2 $4"."\n" if $debug;
	}
	elsif ($l =~ /^#define(\s|\t)TOK_(\w+)(\s|\t)+\"(\S+)\".*/) {
		$tok_hash{$2}->{TOK} = $4;
		print $l."\n" if $debug;
		print "$2 $4"."\n" if $debug;
	}
}
close MSGH;

foreach my $key (keys(%tok_hash)) {
	my $tok = $tok_hash{$key}{TOK};
	my $msg = $tok_hash{$key}{MSG};
	print $msg.' 'x(12-length($msg)). $tok."\n" if ($msg and $tok);
}
